#!/usr/bin/env bash

# $1 -- path to image
# $2 -- tmp file with downloaded tags

BASEDIR=/srv/auto_tagger

source $BASEDIR/DeepDanbooru/bin/activate

# Generate tags
deepdanbooru evaluate --project-path model "$1" 2>/dev/null \
    | grep -vE 'Tags of .*:' \
    | sed 's/([0-9]\.[0-9][0-9][0-9]) //g' >> "$2"

# remove blacklisted tags, append character:, deduplicate tags and strip empty lines
cat "$2" |\
    grep -vwFf blacklist.txt |
    sed     -e  's/ //' \
            -e 's/\bsingle\b/solo/' \
            -e 's/\bkakizaki_megu\b/character:kakizaki_megu/' \
            -e 's/\bsuigintou\b/character:suigintou/' \
            -e 's/\bkashiwaba_tomoe\b/character:kashiwaba_tomoe/' \
            -e 's/\bsakurada_jun\b/character:sakurada_jun/' \
            -e 's/\bshinku\b/character:shinku/' \
            -e 's/\bhinaichigo\b/character:hinaichigo/' \
            -e 's/\bsuiseiseki\b/character:suiseiseki/' \
            -e 's/\bkusabue_mitsu\b/character:kusabue_mitsu/' \
            -e 's/\bkanaria\b/character:kanaria/' \
            -e 's/\bkirakishou\b/character:kirakishou/' \
            -e 's/\blaplace_no_ma\b/character:laplace_no_ma/' \
            -e 's/\blaplace\b/character:laplace_no_ma/' \
            -e 's/\bbarasuishou\b/character:barasuishou/' \
            -e 's/\bsouseiseki\b/character:souseiseki/' \
            -e 's/\bsakurada_nori\b/character:sakurada_nori/' \
            -e 's/\bsarah\b/character:sarah/' \
            -e 's/\benju\b/character:enju/' \
            -e 's/\bodille_fosset\b/character:odille_fosset/' \
            -e 's/\bsaito\b/character:saitou/' \
            -e 's/\bkiku\b/character:kiku/' \
            -e 's/\bsaitou\b/character:saitou/' \
            -e 's/\brozen\b/character:rozen/' \
            -e 's/\bmegu_kakizaki\b/character:kakizaki_megu/' \
            -e 's/\bkunkun\b/character:kunkun/' \
            -e 's/character:character:/character:/' \
    | awk '!seen[$0]++' | awk 'NF' > /tmp/tmp_merged_tags.txt

mv /tmp/tmp_merged_tags.txt "$2"

deactivate
